import sys

def writeSentences(chunk, filename, ospl = False):
    with open(filename, 'w') as f:
        for sentence in chunk:
            for token in sentence:
                f.write(token)
                if not ospl:
                    f.write('\n')

def readSentences(filename, drop_newline = False, ospl = False):
    sentences = []
    with open(filename) as f:

        if ospl:
            return f.readlines()

        sentence = []
        for line in f:
            line = line.strip()

            if not line:
                if not drop_newline:
                    sentence.append(line)                    
                if sentence:
                    sentences.append(sentence)
                sentence = []
                continue
            else:
                sentence.append(line)

        if sentence:
            sentences.append(sentence)

    return sentences

def makeToken(token_string):
    
    fields = token_string.split()
    d = {}
    
    d['index'] = fields[0]
    d['form']  = fields[1]
    d['lemma'] = fields[2]
    d['cpos']  = fields[3]
    d['fpos']  = fields[4]

    try:
     d['morph'] = fields[5]
    except IndexError:
     print >> sys.stderr,'Missing morph', token_string
     d['morph'] = '_'

    try:
        d['head'] = fields[6]
    except IndexError:
        d['head'] = '_'

    try:
        d['deprel'] = fields[7]
    except IndexError:
        d['deprel'] = '_'

    return d
    
def tokenToString(d):
    s = '\t'.join((['%s'] * 10))
    s = s % (d['index'], d['form'],  d['lemma'], d['cpos'], d['fpos'], d['morph'], d['head'], d['deprel'], '_', '_')
    return s

def tokenToString09(d):
    s = '\t'.join((['%s'] * 14))
    s = s % (d['index'], 
             d['form'],
             d['glemma'], d['plemma'],
             d['gpos'], d['ppos'],
             d['gmorph'], d['pmorph'],
             d['ghead'], d['phead'],
             d['gdeprel'], d['pdeprel'],
             '_', '_')
    return s

def makeToken09(token_string):
    fields = token_string.split()
    d = {}  
    d['index'] = fields[0]
    d['form']  = fields[1]
    d['glemma'] = fields[2]
    d['plemma']  = fields[3]
    d['gpos']  = fields[4]
    d['ppos']  = fields[5]
    d['gmorph']  = fields[6]
    d['pmorph']  = fields[7]
    d['ghead'] = fields[8]
    d['phead'] = fields[9]
    d['gdeprel'] = fields[10]
    d['pdeprel'] = fields[11]
    return d

def makeLatticeToken(token_string):
    fields = token_string.split()
    d = {}
    
    d['index'] = fields[0]
    d['toindex'] = fields[1]
    d['form']  = fields[2]
    d['lemma'] = fields[3]
    d['cpos']  = fields[4]
    d['fpos']  = fields[5]

    try:
     d['morph'] = fields[6]
    except IndexError:
     print >> sys.stderr,'Missing morph', token_string
     d['morph'] = '_'

    try:
        d['head'] = fields[7]
    except IndexError:
        d['head'] = '_'

    try:
        d['deprel'] = fields[8]
    except IndexError:
        d['deprel'] = '_'

    return d


    d = {}  
    return d

def makePredToken(token_string):
    fields = token_string.split()
    d = {}
    d['form']  = fields[0]
    d['pos'] = fields[1]
    try:
        d['morph'] = fields[2]
    except IndexError:
        d['morph'] = '_'
    return d
